/**
 * @file
 * @brief ߲(IARAGCC)p݊`
 *
 * ̧قׂ͕̺߲gč\z邽߂Atmel802.15.4KwAVR
 * ^`܂݂܂B̧ق͊荞݁Ax~AUSARTȂ̂̂悤AVR@\p
 * ߲׏tgD܂݂܂B
 *
 * \note avrtypes.h\c F_CPUKvƂ(AVR-GCC/avr-libcp)<util/delay.h>
 * ٰނ邽߁Aavrtypes.hݸٰނO\c F_CPU`Ȃ΂Ȃ܂
 * Bavrtypes.h̑Oɐboard.hݸٰނ邱Ƃɂčs܂B
 *
 * $Id: avrtypes.h,v 1.41 2006N1222 06:57:53 sschneid Exp $
 *
 */
/**
 * \author
 *		Atmel Corporation	: http://www.atmel.com \n
 *		xE-Ұ			: avr@atmel.com
 */
/*
 * 쌠 (c) 2006, Atmel Corporation s
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 */

#ifndef AVRTYPES_H
#define AVRTYPES_H

/* === ݸٰ =============================================================== */

#include <stdlib.h>
#include <stdint.h>

/*
 * if defined(__ICCAVR__)IARׂ߲ɓKp܂B
 */
#if defined(__ICCAVR__)

# include <ioavr.h>
# include <intrinsics.h>
# include <pgmspace.h>

/*
 * IARGCCւAVR蓖
 */
//# include "mcu_types.h"

/*
 * elif defined(__GNUC__)GNU Cׂ߲ɓKp܂B
 */
#elif defined(__GNUC__)

# include <avr/io.h>
# include <avr/eeprom.h>
# include <avr/interrupt.h>
# include <avr/pgmspace.h>
# include <avr/sleep.h>
# include <avr/wdt.h>

# include <util/crc16.h>
# include <util/delay.h>

/*
 * else͖xׂ߲ɓKp܂BIARGNU CȊO̺߲חp̎x
 * uꏊłB
 */
#else
# error Unsupported compiler
#endif /* ߲ו */

/* === O ================================================================== */

/* === ϸ =================================================================== */

#ifndef _BV
/** ޯĒl -- ޯĈʒuɑ΂ޯĎՕvZ */
# define _BV(x) (1 << (x))
#endif

/** ϸۂ͊荞ݏԂۑAʓIcli()̑OɎg܂B */
#define save_irq_status() (sreg = SREG)
/** ϸۂsave_irq_status()ƋɎgȂ΂Ȃ炸A荞ݏԂ̓e
r܂B */
#define restore_irq_status() (SREG = sreg)

/*
 * ̉͒PɑSĂ̺߲׈ˑϸۂɑ΂镶܂݂܂B
 */
#if defined(DOXYGEN)

#define ISR(vec) void handler_##vec(void)	/** ޸\c vecɑ΂銄荞ݏJn */

#define sei()								/** S̊荞݋ */
#define cli()								/** S̊荞݋֎~ */
#define EEGET(var, addr)					/** EEPROM\c addr̓eϐ\c vaɓǂݍ */
#define nop()								/** ȂAP1CPUQ */
#define wdt_reset()							/** ޯތv(A0ؾ) */

#define sleep_mode()						/** \c set_sleep_modeőI񂾋x~ɏ]CPUx~ɒu܂B */
#define SLEEP_MODE_IDLE						/** ًx~ֈڍsBCPUOFFɂ܂ASĂ̸ۯ͑s𑱂܂B */
#define SLEEP_MODE_ADC						/** CPU~܂AADC̑s𑱂܂B */
#define SLEEP_MODE_PWR_DOWN					/** CPUƑSĂ̔U~ */
#define SLEEP_MODE_PWR_SAVE					/** CPUƔ񓯊USĂ̔U~ */
#define SLEEP_MODE_STANDBY					/** CPU~܂AOȖs𑱂܂B */
#define SLEEP_MODE_EXT_STANDBY				/** ܰޓ̂悤łAOȖs𑱂܂B */
#define SLEEP_MODE_MASK						/** SĂ̋x~ޯ */
#define set_sleep_mode(x)					/** \c sleep_modeĂяoœx~ݒ */

/* ۸ ؋Ԓۉ */
#define FLASH_DECLARE(x)					/** ׯROMɒu\c xΏە錾 */
#define FLASH_STRING(x)						/** ׯROMɒu\c x錾 */
#define FLASH_STRING_T						/** ׯROMɒu镶̌^ */
#define PGM_READ_BYTE(x)					/** ׯROM̱ڽ\c x1޲ēǂݍ */
#define PGM_READ_WORD(x)					/** ׯROM̱ڽ\c x2޲ēǂݍ */
#define PGM_READ_BLOCK(dst, src, len)		/** ׯROM̱ڽ\c src\c len޲Ẳڽ\c dstRAMɓǂݍ */
#define PGM_STRLEN(x)						/** ׯROM̱ڽ\c xɒuꂽ̕񒷂𑪒 */
#define PGM_STRCPY(dst, src)				/** ׯROM̱ڽ\c src̕ڽ\c dstRAMɕ */
#define HAS_PGM_VSNPRINTF					/** ߲׊vsnprintf_P()֐xꍇA1ɐݒ
												(vsnprintf()̂悤łAׯROM̌`܂B */
#define PGM_VSNPRINTF(dst, n, fmt, ap)		/** ׯROMŌ`o͂̂Ɏg֐`A
												Ұvsnprintf()ƓlłB */
#define PRINTF_FLASH_STRING					/** RAMނׯROMɒu镶ŵɎg%`wq̂߂ɂ`B
												߲يprintf()l̊֐ׯROM̈邱ƂxȂꍇɂϸۂ`ȂłB */

#define CRC_CCITT_UPDATE(crc, data)			/** \c data޲Ă16ޯCCITT \c crcXVĐVCRCԂ܂B */

#define ALIGN8BIT							/** 8ޯĈɋ邽߂ɍ\̕WɓKp鑮 */

#define SHORTENUM							/** SĂ̒l\̂ɕKvƂŏ̌^̑傫ɂ邽߂ɗ񋓐錾ɓKp鑮 */

#define ENABLE_XRAM(void)					/** main()܂łɑ点ʏ֐̖O */

#define RETURN_ENABLE_XRAM					/** ΁AENABLE_XRAM()ɂĕԂ߂l */

/**
   \c us s̒xs

   F_CPUϸۂ(Hz)CPUۯg`萔`Ǝv܂B

   \ȍőx262.14ms/(Hzł)F_CPU

   \note IARׂ߲ɂāA݁AF_CPU1000000UL(1MHz)̔{łB
 */
extern void delay_us(double us);

#endif /* defined(DOXYGEN) */


#if defined(__ICCAVR__)

/*
 * 荞޸蓖
 */
#if defined(__ATmega128__)
/*
 * ATmega128޸ްĂXMĻقŌLĂ܂BɐK̖O
 * 蓖Ă܂B
 */
#  define USART0_RX_vect	USART0_RXC_vect
#  define USART0_TX_vect	USART0_TXC_vect
#  define USART1_RX_vect	USART1_RXC_vect
#  define USART1_TX_vect	USART1_TXC_vect
#endif /* defined(__ATmega128__) */

/*
 * ̑OIARׂ߲ɑ΂Ċ荞ݏٰݐ錾ͯ ْ̧ۉ
 * ߂ɖ@g܂Bϸۂ̒uƂĎgȂÂ#pragma^
 * ߂ނ)C99_Pragma()^߂ƁA荞޸̊蓖Ă
 * ȂISRp̈ӂ̊֐\z̗s߂2̈قȂ鐅̑OA
 * gƂKvłB
 *
 * ϸۂёւȂłBȂƋ}ɑSĂ̎ނIAR޸ނɂ
 * Čł傤B
 */
#define PRAGMA(x) _Pragma( #x )
#define ISR(vec) PRAGMA( vector=vec ) __interrupt void handler_##vec(void)

#define sei() __enable_interrupt()
#define cli() __disable_interrupt()
#define EEGET(var, addr) __EEGET(var, addr)
#define nop() __no_operation()
#define wdt_reset() __watchdog_reset()

#define sleep_mode() do { MCUCR |= (1 << SE); __sleep(); MCUCR &= ~(1 << SE); } while (0)
#define SLEEP_MODE_IDLE         0
#define SLEEP_MODE_ADC          (1 << SM0)
#define SLEEP_MODE_PWR_DOWN     (1 << SM1)
#define SLEEP_MODE_PWR_SAVE     ((1 << SM0) | (1 << SM1))
#define SLEEP_MODE_STANDBY      ((1 << SM1) | (1 << SM2))
#define SLEEP_MODE_EXT_STANDBY  ((1 << SM0) | (1 << SM1) | (1 << SM2))
#define SLEEP_MODE_MASK         ((1 << SM0) | (1 << SM1) | (1 << SM2))
#define set_sleep_mode(x) do { MCUCR = (MCUCR & ~SLEEP_MODE_MASK) | (x); } while (0)

/* ۸ ؋Ԓۉ */
#define FLASH_DECLARE(x) __flash x
#define FLASH_STRING(x) ((__flash const char *)(x))
#define FLASH_STRING_T  char const __flash *
#define PGM_READ_BYTE(x) *(x)
#define PGM_READ_WORD(x) *(x)
#define PGM_READ_BLOCK(dst, src, len) memcpy_P((dst), (src), (len))
#define PGM_STRLEN(x) strlen_P(x)
#define PGM_STRCPY(dst, src) strcpy_P((dst), (src))
/* IARvsnprintf_P()%S`܂B */
#define HAS_PGM_VSNPRINTF 0
#define PGM_VSNPRINTF(dst, n, fmt, ap) vsnprintf((dst), (n), (fmt), (ap))
#undef PRINTF_FLASH_STRING

#define CRC_CCITT_UPDATE(crc, data) crc_ccitt_update(crc, data)

#define ALIGN8BIT /**/
#define SHORTENUM /**/

#define ENABLE_XRAM(void) \
char __low_level_init(void)
#define RETURN_ENABLE_XRAM return 1

#endif /* defined(__ICCAVR__) */

#if defined(__GNUC__)

#define nop() do { __asm__ __volatile__ ("nop"); } while (0)
#define CRC_CCITT_UPDATE(crc, data) _crc_ccitt_update(crc, data)
#define EEGET(var, addr) (var) = eeprom_read_byte ((uint8_t *)(addr))
#define ALIGN8BIT /* AVR-GCC uses an 8-bit alignment anyway */
#define SHORTENUM __attribute__ ((packed))

/* ۸ ؋Ԓۉ */
#define FLASH_DECLARE(x) x __attribute__((__progmem__))
#define FLASH_STRING(x) PSTR(x)
#define FLASH_STRING_T  PGM_P
#define PGM_READ_BYTE(x) pgm_read_byte(x)
#define PGM_READ_WORD(x) pgm_read_word(x)
#define PGM_READ_BLOCK(dst, src, len) memcpy_P((dst), (src), (len))
#define PGM_STRLEN(x) strlen_P(x)
#define PGM_STRCPY(dst, src) strcpy_P((dst), (src))
/* avr-libcvsnprintf_P()%S܂B */
#define HAS_PGM_VSNPRINTF 1
#define PGM_VSNPRINTF(dst, n, fmt, ap) vsnprintf_P((dst), (n), (fmt), (ap))
#define PRINTF_FLASH_STRING "%S"

#define ENABLE_XRAM(void) \
void xram_init(void) __attribute__((naked)) __attribute((section(".init3")));\
void xram_init(void)
#define RETURN_ENABLE_XRAM /**/

#endif /* defined(__GNUC__) */

/* === ^ ==================================================================== */

/* === ^錾 ============================================================== */

#if defined(__GNUC__)
static inline void delay_us(double us) __attribute__((always_inline));
static inline void
delay_us(double us)
{
	/*
	 * us_delay_loop_1()ɂĈ̂ɏ[ႢꍇAȒlɑ΂Ă
	 * ꂪƐmȂ߂gĂB
	 *
	 * ̔wɂ鐔w: _delay_loop_Nۯɑ΂ۯ(ɑ΂3
	 * ܂4)ƃsړxpɏ悹1E6ɂF_CPUZ
	 */
	if (F_CPU / 3E6 * us < 255)
	{
		uint8_t ticks8 = F_CPU / 3E6 * us;

		_delay_loop_1(ticks8);
	}
	else
	{
		uint16_t ticks16 = F_CPU / 4E6 * us;

		_delay_loop_2(ticks16);
	}
}
#endif /* defined(__GNUC__) */

#ifdef __cplusplus
extern "C" {
#endif

#if defined(__ICCAVR__)
/* CRC_CCITT_UPDATEp⏕֐ */
uint16_t crc_ccitt_update (uint16_t crc, uint8_t data);
#endif /* __ICCAVR__ */

#ifdef cplusplus
} /* extern "C" */
#endif

#endif /* AVRTYPES_H */
/* EOF */
