/* ̧قDoxygenpɏĂ܂B*/
/*! \file *********************************************************************
 *
 * \brief
 *		͒PĳUARTpͯ ̧قłB
 *
 *		̧ق͒PĳUARTp̒`ϸۂ܂݂܂BATmega32ȊÖႤϲ
 *		 ۰ׂgꍇA̧ق͕ύX邱ƂKvłB߰Ăްڰ
 *		̐ݒ̧قŕύX܂B
 *
 * \par pLq:
 *		AVR274: PĳUART
 *
 * \par 
 *		IȺގAxׁ߲A߲אݒAx޲ɂĂ
 *		readme.htmlB
 *
 * \author
 *		Atmel Corporation	: http://www.atmel.com \n
 *		xE-Ұ			: avr@atmel.com
 *
 * $Name		: $
 * $Revision	: 1364 $
 * $RCSfile		: single_wire_UART.h,v $
 * $Date		: 2007N28 14:13:02 +0100 (to, 08 feb 2007) $  \n
 *
 * 쌠 (c) 2006, Atmel Corporation s
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 ******************************************************************************/

#ifndef SW_UART_H
#define SW_UART_H

#define UART_TX_BUFFER_SIZE 32			/* 2,4,8,16,32,64,128܂256޲ */
#define UART_TX_BUFFER_MASK ( UART_TX_BUFFER_SIZE - 1 )
#if ( UART_TX_BUFFER_SIZE & UART_TX_BUFFER_MASK )
	#error TX buffer size is not a power of 2
#endif

#define UART_RX_BUFFER_SIZE 8			/* 2,4,8,16,32,64,128܂256޲ */
#define UART_RX_BUFFER_MASK ( UART_RX_BUFFER_SIZE - 1 )
#if ( UART_RX_BUFFER_SIZE & UART_RX_BUFFER_MASK )
	#error RX buffer size is not a power of 2
#endif

// ްڰĐݒ(WAIT_ONE - PRESCALER):
// ްڰ	1MHz		2MHz		4MHz		8MHz
//   2400	 51 - 8		103 - 8		207 - 8		  NA
//   4800	207 - 1		 51 - 8		103 - 8		(207 - 8)
//   9600	103 - 1		207 - 1		 51 - 8		 103 - 8
//  19200	 NA			103 - 1		207 - 1		  51 - 8
//  28800	 NA			 NA			138 - 1		  34 - 8
//  38400	 NA			 NA			103 - 1		 207 - 1
//
// WAIT_ONEKA~PRESCALER<100UARTSĂCPUɂď邱ƂɒӂĂB

/* ʐMҰBWAIT_ONE`͉pLq̎20-1.ɏ]ĕύXȂ΂Ȃ܂B */
#define WAIT_ONE				207		//!< ޯĊԔrݒB̒ľvZɂĂ͉pLqBvOu킪Ӑ}lɐݒ肳邱ƂmɂĂB
#define PRESCALER				  1		//!< OuݒBްڰĐݒɏ]Đݒ肳Ȃ΂Ȃ܂B

/* ߰Ă݂̐ݒ */
#define SW_UART_PIN_NUMBER		0		//!< ʐMpݔԍݒ
#define SW_UART_PORT			PORTC	//!< ʐMp߰Ăݒ
#define SW_UART_PIN				PINC	//!< ʐMp݂ݒ
//#define SW_UART_DDR			DDRD	//!< ްڼ޽Bd߰Ăɑ΂Ă͗ps\

#define RECEIVE_DELAY			100		//!< JnޯĂ͍̎ŏް ޯĂ̑OɌv튄荞݂Ōv킪ǉ̎Jn邽߂ɌoAeޯĂ̒ɐ旧č̎悷邽߂Ɉǉ̎Ԃ܂B͌v튄荞݂ɂƒxꂽޯĂ܂B

#define WAIT_HALF				((WAIT_ONE+1)/2)
#define WAIT_ONEHALF			(WAIT_ONE + ((WAIT_ONE+1)/2))
#define TIMER_START_TRANSMIT	((uint16_t)(WAIT_ONE-5))
#define TIMER_START_RECEIVE		((uint16_t)(65536-WAIT_HALF+RECEIVE_DELAY))

#define TIMER_PRESCALER_CONTROL_REGISTER	TCCR1B	//!< UARTŎgvɏ]Čv퐧ڼ޽`
#if (PRESCALER == 1)
  #define START_UART_TIMER()	(TIMER_PRESCALER_CONTROL_REGISTER |= (1<<CS10))		// Ⴄv킪gꍇɕύXKvBްĂQƂĂB
  #define STOP_UART_TIMER()		(TIMER_PRESCALER_CONTROL_REGISTER &= ~(1<<CS10))
#elif (PRESCALER == 8)
  #define START_UART_TIMER()	(TIMER_PRESCALER_CONTROL_REGISTER |= (1<<CS11))
  #define STOP_UART_TIMER()		(TIMER_PRESCALER_CONTROL_REGISTER &= ~(1<<CS11))
#else
  #error PRESCALER must be set to 1 or 8
#endif

#if ( ((WAIT_ONEHALF-(RECEIVE_DELAY/PRESCALER)) > 255) || ((WAIT_ONE) > 255))
  #error WAIT_ONE is set too high. Try to increase prescaler or use a higher baud rate.
#endif

#if ( (WAIT_ONE) < (100/PRESCALER))
  #error A too high baud rate is used. Please check the PRESCALER and WAIT_ONE setting.
#endif

/*  ϸ */
#define INITIALIZE_UART_PIN()	( SW_UART_PORT &= ~(1<<SW_UART_PIN_NUMBER) )	//!< ߰ĉ
#define READ_UART_PIN()			( SW_UART_PIN & (1<<SW_UART_PIN_NUMBER) )

/* dAVR߰ėpϸ */
#define SET_UART_PIN()			( SW_UART_PORT &= ~(1<<SW_UART_PIN_NUMBER) )	//!< Hi-Z
#define CLEAR_UART_PIN()		( SW_UART_PORT |= (1<<SW_UART_PIN_NUMBER) )		//!< ݂Lowo͂ɐݒ

/* UART荞޸` */
#define SW_UART_EXTERNAL_INTERRUPT_VECTOR		INT0_vect			//!< UARTO荞޸B͒`UART݂ɏ]ƂmɂĂB
#define SW_UART_TIMER_COMPARE_INTERRUPT_VECTOR	TIMER1_COMPA_vect	//!< UARTr荞͸

/* vϸہB޲ˑłB */
#define SET_UART_TIMER_16BIT_MODE()			(TCCR1A |= (1<<TCW1))	//!< v퐧ڼ޽16ޯēɐݒ
#define CLEAR_UART_TIMER_ON_COMPARE_MATCH()	(TCCR1A |= (1<<WGM10))	//!< v퐧ڼ޽rvŌv(CTC)ɐݒ

#define SET_UART_TIMER_COMPARE_REGISTER(x)	(OCR1B = (uint8_t)((x)>>8), OCR1A = (uint8_t)((x)))		//!< 16ޯČvrڼ޽ݒB荞݋֎~łs
#define SET_UART_TIMER_COMPARE_WAIT_ONE()	(SET_UART_TIMER_COMPARE_REGISTER(WAIT_ONE))				//!< vrڼ޽1ɐݒ

#define SET_UART_TIMER_VALUE(x)				(TCNT1 = (x))

#define CLEAR_UART_TIMER()					(TCNT1 = 0x00)
#define ENABLE_UART_TIMER_INTERRUPT()		(TIMSK1 |= (1<<OCIE1A))
#define DISABLE_UART_TIMER_INTERRUPT()		(TIMSK1 &= ~(1<<OCIE1A))
#define CLEAR_UART_TIMER_INTERRUPT_FLAG()	(TIFR1 = (1<<OCF1A))

/* O荞ϸہB޲ˑłB */
#define INITIALIZE_UART_EXTERNAL_INTERRUPT()	(EICRA |= (1<<ISC01))	//!< INT0̉~[荞݂𐶐悤ɐݒ
#define ENABLE_UART_EXTERNAL_INTERRUPT()		(EIMSK |= (1<<INT0))	//!< UARTpO荞݂
#define DISABLE_UART_EXTERNAL_INTERRUPT()		(EIMSK &= ~(1<<INT0))	//!< UARTpO荞݂֎~
#define CLEAR_UART_EXTERNAL_INTERRUPT_FLAG()	(EIFR = (1<<INTF0))		//!< UARTpO荞ݗv׸ނ

/* ڼ޽` */
#define SW_UART_DECLINE_NEW_TX_DATA		3	//!< ꂪ^̏ꍇAMɏՕɒuׂްPɔj܂B
#define SW_UART_RX_COMPLETE				4	//!< ޲ĂMꂽɐݒ
#define SW_UART_RX_BUFFER_OVERFLOW		6	//!< MɏՕꂽꍇɐݒBް܂B
#define SW_UART_FRAME_ERROR				7	//!< ڰшُ킪Nꍇɐݒ

/* ׸ ϸ */
#define SET_FLAG(flag_register,flag_bit)	( (flag_register) |= (1 << (flag_bit)) )	//!< ڼ޽׸ނݒ肷鎞ɂϸۂgĂB
#define CLEAR_FLAG(flag_register,flag_bit)	( (flag_register) &= ~(1 << (flag_bit)) )	//!< ڼ޽׸ނ鎞ɂϸۂgĂB
#define READ_FLAG(flag_register,flag_bit)	( (flag_register) & (1 << (flag_bit)) )		//!< ڼ޽׸ނǂގɂϸۂgĂB


extern uint8_t SW_UART_status;		//!< ׸ނێ޲
extern uint8_t SW_UART_counter;		//!< v튄荞݂Ŏgvێ

// pڼ޽UART_counteruɂ͂gĂBvϐ̈ȑO̐錾(܂single_wire_UART.cł̐錾)𒍎
// ɂ̂ƁAꂪg鎞ڼ޽15{邱ƂYȂłBIARCӑIƭC/C++߲׋敪
// ދ扺ōs܂B
//__no_init __regvar volatile uint8_t SW_UART_status @ 15;

// pڼ޽UART_statusuɂ͂gĂBvϐ̈ȑO̐錾𒍎߂ɂ̂ƁAꂪg鎞ڼ
// 14{邱ƂYȂłBIARCӑIƭC/C++߲׋敪̺ދ扺ōs܂B
//__no_init __regvar volatile uint8_t UART_counter @ 14;

// ėpI/Oڼ޽UART_statusuɂ͂gĂBp\ȂAGPIOڼ޽̱ڽ邽߂޲ް
// Ă𒲂ׂĂ(ł0x1Eɐݒ)BGPIOڼ޽g鎞͏ԕϐ̈ȑO̐錾(܂single_wire_UART.cł̐錾)
// 𒍎߂ɂĂB
//__io __no_init static volatile uint8_t SW_UART_status @ 0x1E;


/* SUART֐ */
void    SW_UART_Enable(void);		//!< UART
void    SW_UART_Disable(void);		//!< UART֎~
void    SW_UART_Transmit(uint8_t);	//!< 1޲đM
bool    SW_UART_TX_Buffer_Empty();	//!< MɏՕ?

uint8_t SW_UART_Getchar();			//!< MɏՕ1擾
bool    SW_UART_Data_Available();	//!< MɏՕŗp\ްL?

void    SW_UART_Flush_Buffers();	//!< TXRX̗ɏՕj

#endif
