/* ̧قDoxygenpɏĂ܂B*/
/*! \file *********************************************************************
 *
 * \brief
 *		dr߯p`̧
 *
 * \par pLq:
 *		AVR456: SB201̧ѳ
 *
 * \par 
 *		IȺގAxׁ߲A߲אݒAx޲ɂĂ
 *		readme.htmlB
 *
 * \author
 *		Atmel Corporation	: http://www.atmel.com \n
 *		xE-Ұ			: avr@atmel.com
 *
 * $Revision	: $
 * $Date		: $ \n
 *
 * 쌠 (c) 2006, Atmel Corporation s
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 ******************************************************************************/

#include "common.h"
#include "battery_pack_parameters.h"
#include "battery_current_monitoring.h"
#include "battery_protection.h"
#include "cc_gas_gauging.h"
#include "gas_gauging.h"
#include "rtc.h"

/******************************************************************************
 َ̧Ұ
******************************************************************************/
//! EEPROMɕۑꂽ
__eeprom uint16_t cycleCount @ EEPROM_CYCLE_COUNT = 0;

/*****************************************************************************
 ̧ͯقexternɂꂽϐ
 *****************************************************************************/
struct battParam_sramstruct battParams_sram;

// 炪ύX鎞battery_pack_parameters.h
// REMAINING_CAPACITY_TABLE_SIZE̍XVmɂĂB
//! ǂ̓dremainingCapacityZlۑ邩?
__flash uint16_t remainingCapacityCalibrationCurrents[] = {0, 163, 325, 650, 1000};
//! edpRemainingCapacityZ
// ׂ: e퉷xƂꂪsɍXVׂłB
__flash uint8_t  remainingCapacityCalibration[] = {0,  4,  8,  12,  25}; 

/******************************************************************************
 ֐錾
******************************************************************************/
/******************************************************************************/
/*! \brief SBS𕡎
 *
 * EEPROM1̉򖽗ߒ̉]֕
 *
 *	\param	source		񂪓ǂ܂L(ʒuwq)
 *	\param	destination	񂪏L(ʒuwq)
 */
void BATTPARAM_GetString( BATTPARAM_blockParameter_t * source, SBS_command_t* destination )
{
	for(uint8_t i = 0; i < SBSDATA_BLOCK_LENGTH; ++i) {
		destination->payload[i] = *((uint8_t __eeprom*)source + i);
	}
}

/*! \brief 񐔂Ԃ܂B
 *
 * Returns	[d
 */
uint16_t BATTPARAM_GetCycleCount() {
	return cycleCount;
}

/*! \brief 񐔂1
 *
 */
void BATTPARAM_IncreaseCycleCount() {
	++cycleCount;
}

/*! \brief battParams\̂ɕۑтƂ𒲍
 *
 * \note ׂ: ͍\̂uint8_tɷĂ邱ƂłȂ߁A\
 *					 ̍ŏmanufacturerNameKvƂ܂Bт͍Ō
 *					 łȂ΂Ȃ܂B
 *
 * \retval	true	CRC͐B
 * \retval	false	CRC͕słB
 */
bool BATTPARAM_CheckCRC() {
	uint8_t __eeprom *paramByte = battParams.manufacturerName;
	uint8_t __eeprom *endByte = (uint8_t __eeprom*)&battParams.crcChecksum;
	uint16_t crc = 0xFFFF;		// CRC-CCITTpWJnl

	for( ; paramByte != endByte; ++paramByte) {
		crc = crc_ccitt_update(crc, *paramByte);
	}

	return (crc == battParams.crcChecksum);
}

/*********************************************/
/*! SRAMdrҰvZ
 */
void BATTPARAM_InitSramParameters() {
	// ł̊d臒l
	battParams_sram.activeCurrentThresholdInTicks = BATTCUR_mA2Ticks(battParams.activeCurrentThreshold);

	// ݐςꂽCCł̊S[de
	battParams_sram.capacityInCCAccumulated = CCGASG_mAh2Acc(battParams.fullChargeCapacity);

	// ݐςꂽCCł̏I[dx
	battParams_sram.terminateDischargeLimit = CCGASG_mAh2Acc(battParams.terminateDischargeLimit);

	// ceʍZp̒l
	GASG_CalculateRemainingCapacityValues();
}
